#/usr/bin/env sh

# Copyright INRA (Institut National de la Recherche Agronomique)
# http://www.inra.fr
# http://urgi.versailles.inra.fr
#
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.


DIR_BATCHES=$1
DIR_PROFILES=$2

if [ "$1" == "-h" ]; then
  echo "Usage: ITSExtractorDataBanks.sh [directory path to batches] [directory path to profiles]"
  exit
fi

if [ -z "$DIR_BATCHES" ]; then
  echo "missing first argument: directory of batches"
  exit
fi

if [ -z "$DIR_PROFILES" ]; then
  echo "missing second argument: directory of profiles"
  exit
fi

# get full pathdir if relative supplied
DIR_BATCHES="$(dirname $(readlink -e $DIR_BATCHES))/$(basename $DIR_BATCHES)"
DIR_PROFILES="$(dirname $(readlink -e $DIR_PROFILES))/$(basename $DIR_PROFILES)"


if [ ! -d "$DIR_BATCHES" ]; then
  echo "$DIR_BATCHES does not exist !"
  exit
fi

if [ ! -d "$DIR_PROFILES" ]; then
  echo "$DIR_PROFILES does not exist !"
  exit
fi

# read the number of files to analyze
count=`ls -l $DIR_BATCHES/*.fa | wc -l`

# verbose
echo "There are $count files to analyze"

index=0

for i in `ls $DIR_BATCHES/*.fa | sort -g`
do
  echo $i
  index=$(($index + 1))
  mkdir $DIR_BATCHES/$index
  
  echo 'perl '$REPET_PATH'/Gnome_tools/FungalITSextractorURGI.pl '$i' '$DIR_BATCHES'/'$index' '$DIR_PROFILES > $DIR_BATCHES/$index/job_$index.sh

  qsub -V -N ITS_EXTRACTION -wd $DIR_BATCHES/$index $DIR_BATCHES/$index/job_$index.sh

done
