#! /usr/bin/env python

# Copyright INRA (Institut National de la Recherche Agronomique)
# http://www.inra.fr
# http://urgi.versailles.inra.fr
#
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

import re
from commons.core.seq.BioseqDB import BioseqDB

class Taxonomy(object):

    def __init__(self, taxonomy, referenceID, nbSequence):
        self._taxonomyFound = taxonomy
        self._referenceID = referenceID
        self._nbSequence = nbSequence
        self._regexp = re.compile("%s " % self._referenceID)
        self._refSeq = ""
        self._header = ""

    def getRefSeq(self):
        return self._refSeq

    def getTaxonomyFound(self):
        return self._taxonomyFound

    def getReferenceID(self):
        return self._referenceID

    def getNbrSequence(self):
        return self._nbSequence

    def getSequenceHeader(self):
        return self._header

    def getReferenceSequence(self, repFastaFile):
        iBioseqDB = BioseqDB()
        iBioseqDB.load(repFastaFile)
        lHeader = iBioseqDB.getHeaderList()
        for header in lHeader:
            if self._regexp.match(header):
                self._refSeq = iBioseqDB.fetch(header).getSequence()
                self._header = header.split(" ")[1]
                break


