import os
import unittest
from commons.core.utils.FileUtils import FileUtils

class Test_F_countNumber(unittest.TestCase):

    def setUp(self):
        self.inputGFF = "%s/SMART/data/countNumber_inputGFF.gff" % os.environ["REPET_PATH"]
        self.expCSV = "countNumber_expCSV.csv"
        self.outputCSV = "countNumber_obs.csv"

    def tearDown(self):
        try:
            os.remove(self.outputCSV)
        except:
            pass
        try:
            os.remove(self.expCSV)
        except:
            pass

    def test_runAsScript(self):
        cmd = "%s/SMART/DiffExpAnal/countNumber.py " % os.environ["REPET_PATH"]
        cmd += "-i %s " % self.inputGFF
        cmd += "-o %s" % self.outputCSV
        os.system(cmd)
        
        with open(self.expCSV, "w") as f:
            f.write("27049145\t0\n")
            f.write("27049144\t0\n")
            f.write("Potri.012G142600.3\t197\n")
            f.write("Potri.012G075400.1\t0\n")
            f.write("PAC:27049141\t44\n")
            f.write("PAC:27049140\t58\n")
            f.write("27049143\t0\n")
            f.write("27014616\t0\n")
            f.write("Potri.002G205000.1\t68\n")
            f.write("Potri.002G050700.1\t1\n")
            f.write("PAC:27020304\t0\n")
            f.write("PAC:27020305\t0\n")
            f.write("PAC:27049149\t197\n")
            f.write("PAC:27049148\t197\n")
            f.write("PAC:27020300\t1\n")
            f.write("PAC:27020301\t212\n")
            f.write("PAC:27032978\t8\n")
            f.write("PAC:27032979\t8\n")
            f.write("PAC:27048391\t0\n")

        self.assertTrue(FileUtils.are2FilesIdentical(self.outputCSV, self.expCSV))


if __name__ == "__main__":
    unittest.main()