import os
import unittest
from commons.core.writer.TabWriter import TabWriter
from commons.core.utils.FileUtils import FileUtils


class Test_TabWriter(unittest.TestCase):
  
    def test_writer(self):
        inputFileName = "InFile.txt"
        f = open(inputFileName, "w")
        f.write("arm_X S-MART transcript 1000 4000 . + . nbOccurrences=2;ID=test1.1-1;occurrence=1;Name=test1.1 \n")
        f.write("arm_X S-MART exon 1000 2000 . + . ID=test1.1-1-exon1;Name=test1.1-exon1;Parent=test1.1-1 \n")
        f.write("arm_X S-MART exon 3000 4000 . + . ID=test1.1-1-exon2;Name=test1.1-exon2;Parent=test1.1-1 \n")
        f.close()
        
        obsFileName = "InFile.txt.tab"
        
        writer = TabWriter(inputFileName)
        writer.writeFileinTabFormat()
        expFileName = "expFile.tab"
        f = open(expFileName, "w")
        f.write("arm_X\tS-MART\ttranscript\t1000\t4000\t.\t+\t.\tnbOccurrences=2;ID=test1.1-1;occurrence=1;Name=test1.1\n")
        f.write("arm_X\tS-MART\texon\t1000\t2000\t.\t+\t.\tID=test1.1-1-exon1;Name=test1.1-exon1;Parent=test1.1-1\n")
        f.write("arm_X\tS-MART\texon\t3000\t4000\t.\t+\t.\tID=test1.1-1-exon2;Name=test1.1-exon2;Parent=test1.1-1\n")
        f.close()
        
        self.assertTrue(FileUtils.are2FilesIdentical(expFileName, obsFileName))
        
        os.remove(inputFileName)
        os.remove(expFileName)
        os.remove(obsFileName)
        
if __name__ == '__main__':
    unittest.main()
