import os
import unittest
from commons.core.utils.FileUtils import FileUtils

class Test_F_LaunchMreps(unittest.TestCase):
    
    def setUp(self):
        self._inputFastaFileName = "input.fa"
        os.symlink("%s/TEannot/Step3/batches/batch_1.fa" % os.environ["REPET_DATA"], "batch_1.fa")
        os.symlink("%s/TEannot/Step3/batches/batch_2.fa" % os.environ["REPET_DATA"], "batch_2.fa")
        os.system("cat batch_1.fa >> %s" % self._inputFastaFileName)
        os.system("cat batch_2.fa >> %s" % self._inputFastaFileName)

        self._obsMrepsOutputFileName = "obsMreps.Mreps.set"
        self._expMrepsOutputFileName = "expMreps.Mreps.set"
        os.symlink("%s/TEannot/Step4/DmelChr4_TEannot_Mreps.set" % os.environ["REPET_DATA"], self._expMrepsOutputFileName)
        
    def tearDown(self):
        lFilesToRemove = [self._inputFastaFileName, self._expMrepsOutputFileName, self._obsMrepsOutputFileName, "batch_1.fa", "batch_2.fa"]
        for f in lFilesToRemove:
            try:
                os.remove(f)
            except:
                pass
    
    def test_run_as_script(self):
        cmd = "launchMreps.py -i %s -o %s -v 0 -c" % (self._inputFastaFileName, self._obsMrepsOutputFileName)
        os.system(cmd)
        self.assertTrue(FileUtils.are2FilesIdentical(self._expMrepsOutputFileName, self._obsMrepsOutputFileName))
        
if __name__ == "__main__":
    unittest.main()
