import unittest
import os
from commons.core.utils.FileUtils import FileUtils
from commons.launcher.LaunchPals import LaunchPals

class Test_F_LaunchPals(unittest.TestCase):

    def setUp(self):
        self._inputFilePath = "%s/SATannot/Step1/Atha5Chr4_chunks.fa" % os.environ["REPET_DATA"]
        inputFileName = os.path.basename(self._inputFilePath)
        self._expPalsOutput =  "%s/commons/exp_pals.gff" % os.environ["REPET_DATA"]
        self._obsPalsOutput = "%s_%s.gff" % (os.path.splitext(inputFileName)[0], "Pals")
        
    def tearDown(self):
        if FileUtils.isRessourceExists(self._obsPalsOutput):
            os.remove(self._obsPalsOutput)

    def test_run_as_script(self):
        cmd = "LaunchPals.py -q %s" % (self._inputFilePath)
        os.system(cmd)
        self.assertTrue(FileUtils.are2FilesIdentical(self._expPalsOutput, self._obsPalsOutput))
        
    def test_run(self):
        iLaunchPals = LaunchPals(self._inputFilePath, verbosity = 5)
        iLaunchPals.run()
        self.assertTrue(FileUtils.are2FilesIdentical(self._expPalsOutput, self._obsPalsOutput))
        
if __name__ == "__main__":
    unittest.main()