from commons.core.utils.FileUtils import FileUtils
from commons.launcher.LaunchtRNAscanSE import LaunchtRNAscanSE
import unittest
import os

class Test_LaunchtRNAscanSE(unittest.TestCase):
    
    def setUp(self):
        self._iLauncher = LaunchtRNAscanSE()

    def test_formatedLine(self):
        obsLine = self._iLauncher.formatedLine("ALPINE1:classI:SINE:SINE2/tRNA\t1\t4\t75\tAla\tAGC\t0\t0\t68.72")
        expLine = "Ala|AGC|intron=0-0|68.72\tALPINE1:classI:SINE:SINE2/tRNA\t4\t75"
        self.assertEquals(expLine,obsLine )
        
    def test_tab2Map(self):
        inputFileName = "file.fa"
        tabFileName = "file_tRNAscanSE.tab"
        f = open(tabFileName, 'w')        
        f.write('Bovc-tA2:classI:SINE:SINE2/tRNA\t1\t6\t77\tPseudo\tGCA\t0\t0\t42.11\n')
        f.write('Bovc-tA2:classI:SINE:SINE2/tRNA\t2\t125\t196\tPseudo\tGCA\t0\t0\t41.04\n')
        f.write('SINE2-1_Pca:classI:SINE:SINE2/tRNA\t1\t3\t73 \tGly\tTCC\t0\t0\t68.39\n')
        f.write('SINE_FR2:classI:SINE:?\t1\t5\t77\tPseudo\t???\t0\t0\t36.92\n')
        f.write('SINEC1B2_CF:classI:SINE:?\t1\t6\t88\tPseudo\tTTG\t42\t53\t23.60\n')
        f.write('ALPINE1:classI:SINE:SINE2/tRNA\t1\t4\t75\tAla\tAGC\t0\t0\t68.72\n')
        f.close()

        expFileName = "exptRNAscanSE.map"
        f = open(expFileName, 'w')        
        f.write('Pseudo|GCA|intron=0-0|42.11\tBovc-tA2:classI:SINE:SINE2/tRNA\t6\t77\n')
        f.write('Pseudo|GCA|intron=0-0|41.04\tBovc-tA2:classI:SINE:SINE2/tRNA\t125\t196\n')
        f.write('Gly|TCC|intron=0-0|68.39\tSINE2-1_Pca:classI:SINE:SINE2/tRNA\t3\t73\n')
        f.write('Pseudo|???|intron=0-0|36.92\tSINE_FR2:classI:SINE:?\t5\t77\n')
        f.write('Pseudo|TTG|intron=42-53|23.60\tSINEC1B2_CF:classI:SINE:?\t6\t88\n')
        f.write('Ala|AGC|intron=0-0|68.72\tALPINE1:classI:SINE:SINE2/tRNA\t4\t75\n')
        f.close()
        
        obsFileName =  "file.fa.tRNA.map"
        self._iLauncher.setInputFileName(inputFileName)
        self._iLauncher.setOutputFileName("")
        self._iLauncher.tab2Map()
        self.assertTrue(FileUtils.are2FilesIdentical(expFileName, obsFileName))
        os.remove(tabFileName)
        os.remove(expFileName)
        os.remove(obsFileName)
        
if __name__ == "__main__":
    unittest.main()