import unittest
import os
from commons.core.utils.FileUtils import FileUtils
from commons.tools.GetClassifUniq import GetClassifUniq

class Test_F_GetClassifUniq(unittest.TestCase):


    def setUp(self):
        self._inFastaFileName = "%s/Tools/consensus_without_redundancy.fa" % os.environ["REPET_DATA"]
        self._inClassifFileName = "%s/Tools/consensus_classif_redundant.classif" % os.environ["REPET_DATA"]

    def tearDown(self):
        pass

    def test_run(self):
        iGetClassifUniq = GetClassifUniq(self._inFastaFileName, self._inClassifFileName)
        iGetClassifUniq.run()
        
        expFileName = "%s/Tools/consensus_classif_withoutRedundancy.classif" % os.environ["REPET_DATA"]
        obsFileName = "%s_withoutRedundancy.classif" % os.path.splitext(os.path.basename(self._inClassifFileName))[0]
        
        self.assertTrue(FileUtils.are2FilesIdentical(expFileName, obsFileName))
        
        os.remove(obsFileName)

if __name__ == "__main__":
    unittest.main()