import unittest
from commons.tools.RenameHeaderClassif import RenameHeaderClassif
from commons.tools.RenameHeaderClassif import Classif

class Test_RenameHeaderClassif(unittest.TestCase):

    def test_createClassifInstance_confusness_ok(self):
        line = "gypsy5\t7369\t+\tok\tI\tLTR\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RLX", "", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_confusness_PotentialChimeric(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tLTR\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RLX", "chim", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_completness_impcomp(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tLTR\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RLX", "chim", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_completness_complete(self):
        line = "gypsy5\t7369\t+\tok\tI\tLTR\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "RLX", "", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_completness_NA(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tLTR\tNA\tblabla"
        expClassif = Classif("gypsy5", "RLX", "chim", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_all_orders(self):
        line = "gypsy5\t7369\t+\tok\tI\tLTR\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RLX", "", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tDIRS\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "RYX", "chim", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tPLE\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RPX", "chim", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tLINE\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "RIX", "chim", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tok\tI\tSINE\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "RSX", "", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
        line = "gypsy5\t7369\t+\tok\tI\tLARD\tNA\tblabla"
        expClassif = Classif("gypsy5", "RXX-LARD", "", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tTRIM\tNA\tblabla"
        expClassif = Classif("gypsy5", "RXX-TRIM", "chim", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tok\tII\tTIR\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "DTX", "", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tPotentialChimeric\tII\tCrypton\tincomplete\tblabla"
        expClassif = Classif("gypsy5", "DYX", "chim", "incomp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
        line = "gypsy5\t7369\t+\tok\tII\tHelitron\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "DHX", "", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
        line = "gypsy5\t7369\t+\tPotentialChimeric\tII\tMaverick\tcomplete\tblabla"
        expClassif = Classif("gypsy5", "DMX", "chim", "comp") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
        line = "gypsy5\t7369\t+\tPotentialChimeric\tII\tMITE\tNA\tblabla"
        expClassif = Classif("gypsy5", "DXX-MITE", "chim", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_ClassI_No_order(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tI\tnoCat\tNA\tblabla"
        expClassif = Classif("gypsy5", "RXX", "chim", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_ClassII_No_order(self):
        line = "gypsy5\t7369\t+\tok\tII\tnoCat\tNA\tblabla"
        expClassif = Classif("gypsy5", "DXX", "", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_different_orders_same_CI_classII(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tII\tTIR|MITE\tNA\tblabla"
        expClassif = Classif("gypsy5", "DXX", "chim", "") 
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_createClassifInstance_different_orders_same_CI_no_class(self):
        line = "gypsy5\t7369\t+\tPotentialChimeric\tnoCat\tSINE|MITE\tNA\tblabla"
        expClassif = Classif("gypsy5", "XXX", "chim", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_SSR(self):
        line = "cons\t780\t.\tPotentialChimeric\tNA\tSSR\tNA"
        expClassif = Classif("cons", "SSR", "chim", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_rDNA(self):
        line = "cons\t780\t.\tok\tNA\trDNA\tNA"
        expClassif = Classif("cons", "rDNA", "", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_PotentialHostGene(self):
        line = "cons\t780\t.\tok\tNA\tPotentialHostGene\tNA"
        expClassif = Classif("cons", "PotentialHostGene", "", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_noCat_noCat(self):
        line = "cons\t780\t.\tok\tnoCat\tnoCat\tNA"
        expClassif = Classif("cons", "noCat", "", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
    
    def test_createClassifInstance_noCat_noCat_PotentialChimeric(self):
        line = "cons\t780\t.\tPotentialChimeric\tnoCat\tnoCat\tNA"
        expClassif = Classif("cons", "noCat", "chim", "")
        iRHC = RenameHeaderClassif()
        obsClassif = iRHC.createClassifInstance(line)
        self.assertEquals(expClassif, obsClassif)
        
    def test_shortenConsensusName(self):
        projectName = "Vigne_1_3_12_1"
        iClassif = Classif("Vigne_1_3_12_1_Blaster_Grouper_3678_Map_14", "RE", "chim", "comp")
        iClassif.setProjectName(projectName)
        obsConsensusName = iClassif.shortenConsensusName()
        expConsensusName = "Vigne_1_3_12_1-B-G3678-Map14"
        self.assertEquals(expConsensusName, obsConsensusName)
        
    def test_shortenConsensusName_MCL(self):
        projectName = "Vigne_1_3_12_1"
        iClassif = Classif("Vigne_1_3_12_1_LTRharvest_MCL_6101988_Map_14", "RE", "chim", "comp")
        iClassif.setProjectName(projectName)
        obsConsensusName = iClassif.shortenConsensusName()
        expConsensusName = "Vigne_1_3_12_1-L-M6101988-Map14"
        self.assertEquals(expConsensusName, obsConsensusName)
        
    def test_shortenConsensusName_reversed(self):
        projectName = "Vigne_1_3_12_1"
        iClassif = Classif("Vigne_1_3_12_1_Blaster_Grouper_3678_Map_14_reversed", "RE", "chim", "comp")
        iClassif.setProjectName(projectName)
        obsConsensusName = iClassif.shortenConsensusName()
        expConsensusName = "Vigne_1_3_12_1-B-G3678-Map14_reversed"
        self.assertEquals(expConsensusName, obsConsensusName)
        
        # The 3 following tests are designed to test RepeatScout's headers shortening.
        # By now, RS consensus' headers are kept as it (cf. Classif.createNewConsensusName method).
        # If you want to shorten them, uncomment these tests and make them pass, baby.
        #
        # /!\ Be careful! Modify functional tests too, and check TEdenovo's following steps and tests for resulting errors!
        
#    def test_shortenConsensusName_RS(self):
#        projectName = "Vigne_1_3_12_1"
#        iClassif = Classif("Vigne_1_3_12_1_RS_2", "RE", "chim", "comp")
#        iClassif.setProjectName(projectName)
#        obsConsensusName = iClassif.shortenConsensusName()
#        expConsensusName = "Vigne_1_3_12_1-RS2"
#        self.assertEquals(expConsensusName, obsConsensusName)
#        
#    def test_shortenConsensusName_RS_reversed(self):
#        projectName = "Vigne_1_3_12_1"
#        iClassif = Classif("Vigne_1_3_12_1_RS_2_reversed", "RE", "chim", "comp")
#        iClassif.setProjectName(projectName)
#        obsConsensusName = iClassif.shortenConsensusName()
#        expConsensusName = "Vigne_1_3_12_1-RS2_reversed"
#        self.assertEquals(expConsensusName, obsConsensusName)
#        
#    def test_shortenConsensusName_RS_reversed_simpleProjectName(self):
#        projectName = "test"
#        iClassif = Classif("test_RS_2_reversed", "RE", "chim", "comp")
#        iClassif.setProjectName(projectName)
#        obsConsensusName = iClassif.shortenConsensusName()
#        expConsensusName = "test-RS2_reversed"
#        self.assertEquals(expConsensusName, obsConsensusName)
    
if __name__ == "__main__":
    unittest.main()